/* Interface pour l'utilisation de GLUT
 *
 * Projet: Traitement d'images
 * Maitrise informatique 2003
 * Vouriot Thierry
 */

#include "interf-glut.h"
#include "ppm.h"

extern int nbplan;
extern PnmFile fich;
int x,y;

void setTexture(int L, int H, unsigned char *img, int nboct)
{
  glEnable(GL_TEXTURE_2D);
  glShadeModel(GL_FLAT);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glTexImage2D(GL_TEXTURE_2D,0,nboct,H,L,0,GL_RGB,GL_UNSIGNED_BYTE,img);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
}

void dessiner_bitmap_dans_un_polygone(unsigned char *bitmap,int xsize, int ysize)
{
	glMatrixMode(GL_PROJECTION); 
	glLoadIdentity();
	glOrtho(0,xsize,0,ysize, -1.0, 1.0); 
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL); 

	setTexture(xsize, ysize, bitmap, 3);
	glBegin(GL_QUADS);
        glTexCoord2f(0.0, 1.0);
     	glVertex2i(0,0); 
		glTexCoord2f(1.0, 1.0);
     	glVertex2i(xsize-1,0);
		glTexCoord2f(1.0, 0.0);
      	glVertex2i(xsize-1,ysize-1);
		glTexCoord2f(0.0, 0.0);
      	glVertex2i(0,ysize-1);
	glEnd();
}

void re_dessiner_image(int xsize, int ysize, unsigned char *bitmap)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();

	glRasterPos2i(x, y);

	if (nbplan == 3) {
		glDrawPixels(xsize, ysize, GL_RGB, GL_UNSIGNED_BYTE, bitmap);
	}
	else {
		glDrawPixels(xsize, ysize, GL_LUMINANCE, GL_UNSIGNED_BYTE, bitmap);
	}
    //dessiner_bitmap_dans_un_polygone(bitmap, xsize,  ysize);

	glFinish();
	glFlush();
}

void dessiner_nouvelle_image(int tx, int ty, unsigned char *bitmap, int coul)
{
	re_dessiner_image(tx, ty, bitmap);
}

void ouvrir_fenetre_graphique(int px,int py, int xsize, int ysize, unsigned char *bm, int mode_coul)
{
	glutInitWindowPosition(px,py);
	glutInitWindowSize(xsize,ysize);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutCreateWindow("Tothop");
	glClearColor(0.4, 0.4, 0.4, 0.0);

	glMatrixMode(GL_PROJECTION); 
	glLoadIdentity();
	glOrtho(0,xsize,0,ysize, -1.0, 1.0); 
}

void f_reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glOrtho(0.0f, w - 1.0, 0.0, h - 1.0, -1.0, 1.0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	// calcul la position pour afficher l'image
	// au centre de la fentre
	y = h/2 - fich.ysize/2 + 30;
	x = w/2 - fich.xsize/2;
	if (x < 0) x = 0;
	if (y < 70) y = 70;
}

void boucler(void(*f_expose)(void),void(*f_click)(int,int,int,int),void(*f_clavier)(unsigned char,int,int))
{
	glutReshapeFunc(f_reshape);
    glutDisplayFunc(f_expose);
    glutMouseFunc(f_click);
    glutKeyboardFunc(f_clavier);
    glutMainLoop();
}

