/* Fonctions de traitement d'images
 *
 * Projet: Traitement d'images
 * Maitrise informatique 2003
 * Vouriot Thierry
 */

#ifndef _TI_H
#define _TI_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct sRGB {
	int r;
	int g;
	int b;
} RGB;

/* Retourne l'image */
void symetrie_verticale(unsigned char *bitmap, int h, int w, int np);
/* Negatif */
void negatif(unsigned char *bitmap, int h, int w, int np);
/* Niveau de gris */
void niveau_gris(unsigned char *bitmap, int h, int w, int np);
/* Garde les couleurs R, V ou B demandees de l'image */
void couleurs(unsigned char *bm, int h, int w, int np, RGB c);
/* Pour toutes les 3 composantes RVB de tous les pixels de l'image
 * on applique un masque pour ne garder que certains bits
 */
void select_bits(unsigned char *bm, int h, int w, int np, int masque);
/* Egalisation d'histogramme 1 */
void egal_histo_1(unsigned char *bm, int h, int w, int np);
/* Egalisation d'histogramme 2 */
void egal_histo_2(unsigned char *bm, int h, int w, int np);
/* Etirement */
void etirement(unsigned char *bm, int h, int w, int np);
/* Etirement interactif */
void etirement_interactif(unsigned char *bm, int h, int w, int np, int *b); 
/* Seuillage fixe */
void seuillage_fixe(unsigned char *bm, int h, int w, int np, int seuil);
/* Seuillage aleatoire */
void seuillage_al(unsigned char *bm, int h, int w, int np);
/* Dent de scie */
void dent_scie(unsigned char * bm,int h, int w ,int np);
/* 4 distance fond/point */
void distance_point4(unsigned char *bm, int h, int w, int np, RGB c, int *b);
/* 8 distance fond/point */
void distance_point8(unsigned char *bm, int h, int w, int np, RGB c, int *b);
/* Remplissage par balayage */
void remplissage(unsigned char *bm, int h, int w, int np);
/* Mediatrice de 2 points 4 distance */
void mediatrice4(unsigned char * bm,int h, int w ,int np);
/* Mediatrice de 2 points 8 distance */
void mediatrice8(unsigned char * bm,int h, int w ,int np);
/* 4 distance fond/figure */
void distance4_back_fig(unsigned char* bm, int w, int h, int np);
/* 8 distance fond/figure */
void distance8_back_fig(unsigned char* bm, int w, int h, int np);
/* 4 distance figure/fond */
void distance4_fig_back(unsigned char* bm, int w, int h, int np);
/* 8 distance figure/fond */
void distance8_fig_back(unsigned char* bm, int w, int h, int np);
/* Squelettisation M.A.T.*/
void squelet_mat(unsigned char* bm, int w, int h, int np);
/* Squelettisation de Rosenfeld */
void squelet_rosenfeld(unsigned char* bm, int w, int h, int np);
/* Squelettisation de Hilditch */
void squelet_hilditch(unsigned char* bm, int w, int h, int np);

#endif
