/* Programme de traitement d'images
 *
 * Projet: Traitement d'images
 * Maitrise informatique 2003
 * Vouriot Thierry
 */

#include "tothop.h"

PnmFile fich;
int xsize, ysize;
unsigned char * bitmap;
unsigned char * bitmap2;
int nbplan = 1;
char *traitement;
int mouse_coord[4] = { 0, 0, 0, 0 };
RGB cc = { 255, 255, 255};

extern int x,y;

#define SAVE_ANNULER memcpy((void*)bitmap2, (void*)bitmap, xsize*ysize*nbplan*sizeof(unsigned char))

int main(int argc, char **argv)
{
	glutInit(&argc, argv);

	traitement = (char*)calloc(200, sizeof(char));
	if (argc<2) {
		fich.name = "paysage.ppm";
	}
	else fich.name = argv[1];
	printf("Traitements sur l'image :\n");

	lirefich(&fich);
	xsize = fich.xsize;
	ysize = fich.ysize;
	if ((fich.type == 3)||(fich.type==6)) nbplan=3;
  
	bitmap = (unsigned char *) calloc(xsize*ysize*nbplan, sizeof(unsigned char));
	bitmap2 = (unsigned char *) calloc(xsize*ysize*nbplan, sizeof(unsigned char));
	memcpy((void*)bitmap, (void*)fich.bitmap, xsize*ysize*nbplan*sizeof(unsigned char));
	symetrie_verticale(bitmap, ysize, xsize,nbplan);
	memcpy((void*)bitmap2, (void*)bitmap, xsize*ysize*nbplan*sizeof(unsigned char));
	ouvrir_fenetre_graphique(100,100,xsize+6,ysize+72,bitmap,(nbplan==3) );
 
	dessiner_nouvelle_image(xsize, ysize, bitmap, (nbplan==3));
  
	strcpy(traitement, " --- ");
	createMenus();

	printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b);
	printf("Souris DOWN: %d %d\n", mouse_coord[0], mouse_coord[1]);
	printf("Souris UP: %d %d\n", mouse_coord[2], mouse_coord[3]);

	boucler(fn_expose, fn_click, fn_clavier);
	return 0;
}

void fn_expose(void)
{
	dessiner_nouvelle_image(xsize, ysize, bitmap, (nbplan==3));
	
	drawString(x + 5, y-15, GLUT_BITMAP_HELVETICA_12, "Image : %s  (%d*%d %d bits)", fich.name, fich.xsize, fich.ysize, nbplan*8);
	drawString(x + 5, y-30, GLUT_BITMAP_HELVETICA_12, "Couleur courante R=%d G=%d B=%d", cc.r, cc.g, cc.b);
	drawString(x + 5, y-45, GLUT_BITMAP_HELVETICA_12, "Souris position DOWN(%d,%d) UP(%d,%d)", mouse_coord[0], mouse_coord[1], mouse_coord[2], mouse_coord[3]);
	drawString(x + 5, y-60, GLUT_BITMAP_HELVETICA_12, "Dernier traitement : %s", traitement);
	
	glutSwapBuffers();
}

void fn_click(int b, int etat, int x, int y)
{
	if ((b==GLUT_LEFT_BUTTON) && (etat==GLUT_DOWN))
    {
    	mouse_coord[0] = x; mouse_coord[1] = y;
		printf("Souris DOWN: %d %d\n", mouse_coord[0], mouse_coord[1]);
    }
    if ((b==GLUT_LEFT_BUTTON) && (etat==GLUT_UP))
    {
    	mouse_coord[2] = x; mouse_coord[3] = y;
		printf("Souris UP: %d %d\n", mouse_coord[2], mouse_coord[3]);
		glutPostRedisplay();
    }
} 

void fn_clavier(unsigned char car, int x, int y)
{
	FILE *f;
	switch (car)
    {
		case ESC: exit(0);
		case 'f': SAVE_ANNULER; symetrie_verticale(bitmap, ysize, xsize,nbplan); break;
		case 'n': SAVE_ANNULER; negatif(bitmap, ysize, xsize,nbplan); break;
		case 'g': SAVE_ANNULER; niveau_gris(bitmap, ysize, xsize,nbplan); break;
		case 'w':
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			if (nbplan==3) {
			f=fopen("res.ppm","wb");
			fprintf(f,"P6\n%d %d\n255\n",xsize,ysize);
			fwrite(bitmap, 3, xsize*ysize, f);}
			else {
				f=fopen("res.pgm","wb");
	            fprintf(f,"P5\n%d %d\n255\n",xsize,ysize);
		        fwrite(bitmap, 1, xsize*ysize, f);}
			fclose(f);
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			printf("Ecriture res.ppm OK\n");
			strcpy(traitement, " --- ");
			break;
		case 'r':
			memcpy((void*)bitmap, (void*)fich.bitmap, xsize*ysize*nbplan*sizeof(unsigned char));
			printf("Rechargement de l'image\n");
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			strcpy(traitement, " --- ");
			break;

		default : fprintf(stderr,"caractere %c detecte\n",car);
	}

	glutPostRedisplay();
}

/* Fonction gerant les actions sur les menus */
void glutMenu(int value)
{
	FILE *f;
	switch (value) 
	{
		case SYMETRIE_VERTICALE: SAVE_ANNULER; symetrie_verticale(bitmap, ysize, xsize, nbplan); break;
		case NEGATIF: SAVE_ANNULER; negatif(bitmap, ysize, xsize, nbplan); break;
		case NIVEAU_GRIS: SAVE_ANNULER; niveau_gris(bitmap, ysize, xsize, nbplan); break;
		case SELECT_COULEURS: SAVE_ANNULER; couleurs(bitmap, ysize, xsize, nbplan, cc); break;

		case ESC: SAVE_ANNULER; exit(0); break;
		case M00000100: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 4); break;
		case M00001000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 8); break;
		case M00010000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 16); break;
		case M00100000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 32); break;
		case M01000000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 64); break;
		case M10000000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 128); break;
		case M11111110: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 254); break;
		case M11111100: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 252); break;
		case M11111000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 248); break;
		case M11110000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 240); break;
		case M11100000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 224); break;
		case M11000000: SAVE_ANNULER; select_bits(bitmap, ysize, xsize, nbplan, 192); break;
		case EGAL_HISTO_1: SAVE_ANNULER; egal_histo_1(bitmap, ysize, xsize, nbplan); break;
		case EGAL_HISTO_2: SAVE_ANNULER; egal_histo_2(bitmap, ysize, xsize, nbplan); break;
		case ETIREMENT: SAVE_ANNULER; etirement(bitmap, ysize, xsize, nbplan); break;
		case ETIREMENT_INTERACTIF: SAVE_ANNULER; etirement_interactif(bitmap, ysize, xsize, nbplan, mouse_coord); break;
		case SEUILLAGE_FIXE: SAVE_ANNULER; seuillage_fixe(bitmap, ysize, xsize, nbplan, 128); break;
		case SEUILLAGE_AL: SAVE_ANNULER; seuillage_al(bitmap, ysize, xsize, nbplan); break;
		case DENTSCIE: SAVE_ANNULER; dent_scie(bitmap, ysize, xsize, nbplan); break;
		case DISTANCE_POINT4: SAVE_ANNULER; distance_point4(bitmap, ysize, xsize, nbplan, cc, mouse_coord); break;
		case DISTANCE_POINT8: SAVE_ANNULER; distance_point8(bitmap, ysize, xsize, nbplan, cc, mouse_coord); break;
		
		case DISTANCE4_FIG_BACK: SAVE_ANNULER; distance4_fig_back(bitmap, ysize, xsize, nbplan); break;
		case DISTANCE8_FIG_BACK: SAVE_ANNULER; distance8_fig_back(bitmap, ysize, xsize, nbplan); break;
		case DISTANCE4_BACK_FIG: SAVE_ANNULER; distance4_back_fig(bitmap, ysize, xsize, nbplan); break;
		case DISTANCE8_BACK_FIG: SAVE_ANNULER; distance8_back_fig(bitmap, ysize, xsize, nbplan); break;
		case REMPLISSAGE: SAVE_ANNULER; remplissage(bitmap, ysize, xsize, nbplan); break;
		case SQUELET_MAT: SAVE_ANNULER; squelet_mat(bitmap, ysize, xsize, nbplan); break;
		case SQUELET_ROSENFELD: SAVE_ANNULER; squelet_rosenfeld(bitmap, ysize, xsize, nbplan); break;
		case SQUELET_HILDITCH: SAVE_ANNULER; squelet_hilditch(bitmap, ysize, xsize, nbplan); break;
		case MEDIATRICE4: SAVE_ANNULER; mediatrice4(bitmap, ysize, xsize, nbplan); break;
		case MEDIATRICE8: SAVE_ANNULER; mediatrice8(bitmap, ysize, xsize, nbplan); break;

		case BLANC: cc.r = 255; cc.g = 255; cc.b = 255; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case ROUGE: cc.r = 255; cc.g = 0; cc.b = 0; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case VERT: cc.r = 0; cc.g = 255; cc.b = 0; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case BLEU: cc.r = 0; cc.g = 0; cc.b = 255; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case CYAN: cc.r = 0; cc.g = 255; cc.b = 255; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case MAGENTA: cc.r = 255; cc.g = 0; cc.b = 255; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		case JAUNE: cc.r = 255; cc.g = 255; cc.b = 0; printf("Couleur courante RGB: %d %d %d\n",cc.r,cc.g,cc.b); break;
		
		case RECHARGER: 
			memcpy((void*)bitmap, (void*)fich.bitmap, xsize*ysize*nbplan*sizeof(unsigned char));
			printf("Rechargement de l'image\n");
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			strcpy(traitement, " --- ");
			break;
		case ENREGISTRER:
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			if (nbplan==3) {
			f=fopen("res.ppm","wb");
			fprintf(f,"P6\n%d %d\n255\n",xsize,ysize);
			fwrite(bitmap, 3, xsize*ysize, f);}
			else {
				f=fopen("res.pgm","wb");
	            fprintf(f,"P5\n%d %d\n255\n",xsize,ysize);
		        fwrite(bitmap, 1, xsize*ysize, f);}
			fclose(f);
			symetrie_verticale(bitmap, ysize, xsize,nbplan);
			printf("Ecriture res.ppm OK\n");
			strcpy(traitement, " --- ");
	
			break;
		case ANNULER:
			printf("Annuler dernier traitement\n");
			memcpy((void*)bitmap, (void*)bitmap2, xsize*ysize*nbplan*sizeof(unsigned char));
			strcpy(traitement, " --- ");
			break;
	}

	glutPostRedisplay();
}


/* Ecrit du texte a la position x,y (utilise la meme syntaxe que printf()) */
void drawString(int x, int y, void *font, char *s, ...)
{
	int		lines;
	char*	p;
	char	text[1024];
	va_list ap;
	
	if(s==NULL)
		return;

	va_start(ap, s);
	vsprintf(text, s, ap);
	va_end(ap);

	glColor3f(0.0, 0.0, 0.0);
	glRasterPos2i(x+2, y-2);
    for(p = text, lines = 0; *p; p++)
        glutBitmapCharacter(font, *p);
	glColor3f(1.0, 1.0, 1.0);
	glRasterPos2i(x, y);
    for(p = text, lines = 0; *p; p++)
        glutBitmapCharacter(font, *p);
}








  
